//
// FernsehWidget
// Von Pascal Pfiffner und Sebastian Krauß
//

var req;
var previous; // url für die vorigen sendungen
var further; // url für die nächsten sendungen
var currentlyloading;
var progressAnimationTimer;
var currentID;
var currentShowDescURL;

// Which show was previously shown?
var previousShowObject;
var previousShowClass;

function selectValue(element, value)
{
    for (i = 0; i < element.length; i++)
    {
        if (element.options[i].value == value)
        {
            element.selectedIndex = i;
            return;
        }
    }
}

function loaded()
{
    currentID = 0;
    currentlyloading = false;

    // create buttons
	createGenericButton(document.getElementById("done"), "Fertig", savePrefs);

	createGenericButton(document.getElementById("diagnosisbutton"), "Netzwerk-Diagnose...", openDiagnosis);
	createGenericButton(document.getElementById("tryagainbutton"), "Erneut versuchen", getdefault);
    
    // setup prefs
    var opt = document.getElementById("ztag");
    var optvalue = widget.preferenceForKey("day");
    if (undefined != optvalue) selectValue(opt, optvalue);
    opt = document.getElementById("uhrzeit");
    optvalue = widget.preferenceForKey("hour");
    if (undefined != optvalue) selectValue(opt, optvalue);
    opt = document.getElementById("sparte");
    optvalue = widget.preferenceForKey("channelkind");
    if (undefined != optvalue) selectValue(opt, optvalue);
    opt = document.getElementById("sender");
    optvalue = widget.preferenceForKey("channel");
    if (undefined != optvalue) selectValue(opt, optvalue);
    optvalue = widget.preferenceForKey("showShortDesc");
    if ((optvalue != undefined) && (optvalue == "1")) document.getElementById("kurzInfoStandard").checked = true;
    opt = document.getElementById("erinnerung");
    optvalue = widget.preferenceForKey("reminder");
    if (undefined != optvalue)
    {
    	selectValue(opt, optvalue);
    	if (FernsehPlugin) FernsehPlugin.setSecondsBeforeReminder(optvalue);
    	// 120 is the default in the widget and in the gui.
    	// no need to explicitly set it.
    }
	
	if(window.widget)
	{
		widget.onshow = onShow;
		widget.onhide = onHide;
	}

	updateTVListing();
}	

function getdefault()
{
    var day = getListingDay();
    var hour = getListingTime();
    var channelkind = getListingChannelKind();
    var channel = getListingChannel();
	
	var requesturl = "http://www.tvtoday.de/tv/programm/programm.php?ztag=" + day + "&sparte=" + channelkind + "&uhrzeit=" + hour + "&sender=" + channel;

	getURL(requesturl);	
}

function getListingDay()
{
    var opt = document.getElementById("ztag");
    var ret = opt.options[opt.selectedIndex].value;
    return ret;
}

function getListingTime()
{
    var opt = document.getElementById("uhrzeit");
    var ret = opt.options[opt.selectedIndex].value;
    return ret;
}

function getListingChannelKind()
{
    var opt = document.getElementById("sparte");
    var ret = opt.options[opt.selectedIndex].value;
    return ret;
}

function getListingChannel()
{
    var opt = document.getElementById("sender");;
    var ret = opt.options[opt.selectedIndex].value;
    return ret;
}

function getURL(requesturl)
{
    if (currentlyloading) return;
    currentlyloading = true;
    
    //alert(requesturl);
    if(drawer.current > 0) toggleDrawer();
    previousShowObject = null;
    previousShowClass = null;
    
    startProgressAnimation();

	req = new XMLHttpRequest();
    req.onreadystatechange = processReqChange;
    req.open("GET", requesturl, true);
    req.setRequestHeader("Cache-Control", "no-cache");

    req.send(null);
}

function processReqChange()
{
    // alert("State: "+req.readyState+" >> Status: "+req.status+" >> StatusText: "+req.statusText);
    if (req.readyState == 4) currentlyloading = false;
    if ((req.readyState == 4) && (req.status == undefined)) showError();
	if ((req.readyState == 4) && (req.status >= 200) && (req.status < 400)) parseRawHTML(req.responseText);

	// DEBUG ONLY!
	if ((req.readyState == 4) && (req.status >= 400)) showError();
}

function showError()
{
    stopProgressAnimation();
    purgeParagraphs();
    document.getElementById('networkerror').style.display = 'block';
	calculateAndShowThumb(document.getElementById('content'));
}

function startProgressAnimation()
{
	startProgressBar();
}

function stopProgressAnimation()
{
	stopProgressBar();
}

function updateTVListing()
{
	getdefault();
}

var dateFirstShow;
function parseRawHTML(rawsource)
{
	// Das alles zu einer Zeile machen 
	lines = rawsource.split("\n");
	rsource = lines.join("");
	
	// mal datum finden
	datematch = /<!-- Ende ContentAd.*?<span class="headline-balken">&nbsp;&nbsp;P R O G R A M M.*?<span class="text-weiss">([0-9\.]+).*?<\/span>/;
	datematch.exec(rsource);
	dateFirstShow = RegExp.$1;
	document.getElementById('showdate').innerText = dateFirstShow;
	// --- */
	
	// Der entscheidende Teil für das Fernsehprogramm...
	rmatch = /Ende ContentAd.*?<\/table>.*?<img src="..\/bilder\/1x1.gif" width="3" height="3" border="0"><br>(.*?)<img src="\/tv\/bilder\/linie.gif" width="566" height="1" border="0"><br><br><table border="0" cellpadding="2" cellspacing="2" width="566">(.*)$/;

	rmatch.exec(rsource);
	var listing = RegExp.$1;
	
	// Später relevant für "frühere Sendungen" und "weitere Sendungen"
	var afterlisting = RegExp.$2;
	
	shows = new Array();
	showsregexp = /<table border="0" cellpadding="4" cellspacing="0" width="566">\s?<tr>(.*?)<\/tr>/g;
	rawshows = listing.match(showsregexp);

    // Die einzelnen Sendungen zerpflücken
	for (i = 0; i < rawshows.length; i++)
	{
		singleshowregexp = /<td.*?>.*?<\/td>/g;
		thisshow = rawshows[i].match(singleshowregexp);

		iconurlregexp = /<td width="38" valign="top"><img src="([^"]*)" alt="/;
		iconurlraw = thisshow[0].match(iconurlregexp);
		iconurl = iconurlraw[1];
		//alert ("iconurl: "+iconurl);
		
		starttimeregexp = /<td valign="top" bgcolor="#a8a8a8"><span class="text-grau">(.*?)<\/span/;
		starttimeraw = thisshow[1].match(starttimeregexp);
		starttime = starttimeraw[1];
		//alert("start "+starttime);
		
		shownameregexp = /<td valign="middle" width="476"><span class="headline">(<a href.*?><u>)?(.*?)(<\/u>)?<\/span><span class="text">(.*?)\s.*?<\/span>.*?<span class="text">(.*?)\s.*?<\/span>/;
		shownameraw = thisshow[2].match(shownameregexp);
		shownameandchannel = shownameraw[2];
		//alert("start "+starttime);
		
		showurlregexp = /<td valign="middle" width="476"><span class="headline">.*?openWindowLupeCustom\('([^']*?)',/;
		showurlraw = thisshow[2].match(showurlregexp);
		var showurl = null;
		if (showurlraw != null) showurl = showurlraw[1];
        
		showchannelregexp = /(.*?)\s*\((.*)\)/
		showchannel = shownameandchannel.match(showchannelregexp);
		
		showname = showchannel[1];
		channel = showchannel[2];
		
		// mit showview
		//showdescregexp = /<td valign="middle" width="476">.*?<span class="text">\s*?<i>(.*?)\s*?<br>\s*?<\/span>.*?<span class="text">\s*?(.*?)\s*?(<br>)?\s*?<\/span>/;
		// ohne showview -- aber wer braucht das?
		showdescregexp = /<td valign="middle" width="476">.*?<span class="text">\s*?<i>(.*?)<\/i>.*?<\/span>.*?<span class="text">\s*?(.*?)\s*?(<br>)?\s*?<\/span>/;
		showdescraw = thisshow[2].match(showdescregexp);
		
		showlength = "";
		showlength = showdescraw[1];
		showdesc = "";
		if (undefined != showdescraw[2]) showdesc += showdescraw[2];
		
		show = new Array(channel, starttime, showname, iconurl, showdesc, showlength);
		if (showurl != null) show.push(showurl);
		shows[i] = show;
	}
	var day = getListingDay();

	// Das Ergebnis zusammensetzen
	purgeParagraphs();
	
	for (i = 0; i < shows.length; i++)
	{
		thisshow = shows[i];
		showtitle = thisshow[2];
		longdesc = "";
		if (thisshow.length == 7) longdesc = thisshow[6];
		addParagraph(thisshow[1], thisshow[0], showtitle, thisshow[4], longdesc, thisshow[3], thisshow[5]);
	}
	
	// Gibt es weitere oder vorherige Sendungen?
	previousregexp = /<a href="([^"]*)"><span class="link-intern"><img src="\/tv\/bilder\/pfeil_links.gif" width="4" height="7" border="0">&nbsp;fr&uuml;here Sendungen/;
	previousraw = afterlisting.match(previousregexp);
    previous = null;
	if (previousraw != undefined) previous = previousraw[1];
    	
	furtherregexp = /<a href="([^"]*)"><span class="link-intern"> weitere Sendungen/;
	furtherraw = afterlisting.match(furtherregexp);
    further = null;
	if (furtherraw != undefined) further = furtherraw[1];
    
    if (previous == null) document.getElementById("previousShows").style.display = 'none';
    else document.getElementById("previousShows").style.display = 'block';
    
    if (further == null) document.getElementById("nextShows").style.display = 'none';
    else document.getElementById("nextShows").style.display = 'block';
    
    stopProgressAnimation();
    
    document.getElementById('networkerror').style.display = 'none';
    document.getElementById('content').style.top = '0px';
	calculateAndShowThumb(document.getElementById('content'));
}

function toggleShow(showName, time, channel, day, iconurl, buttonID)
{
    button = document.getElementById(buttonID);
    //alert("toggleshow called for show "+showName);
    if (FernsehPlugin.alarmExistsForShow(showName, channel, time, day)) 
    {
        button.setAttribute("src", "Images/AlarmOff.png");
	   	button.setAttribute('title', 'Alarm ist aus');
        FernsehPlugin.removeAlarmForShow(showName, channel, time, day);
    } else {
        button.setAttribute('src', 'Images/AlarmOn.png');
	   	button.setAttribute('title', 'Alarm ist an');
        FernsehPlugin.setAlarmForShow(showName, channel, time, day, iconurl);
    }
}

function toggleRowId(element, button)
{
    var nextelem = element.nextSibling;
    //alert("toggleRow called on element +"+nextelem+"+");
    
    if (nextelem.style.display == 'block')
    {
        nextelem.style.display = 'none';
        button.src='Images/iButton.png';
    } else {
        nextelem.style.display = 'block';
        button.src='Images/iButtonGrau.png';
    }
	calculateAndShowThumb(document.getElementById('content'));
	//alert("done togglerow");
}


var alternateParagraph = false;
function addParagraph(i_time, i_channel, i_title, i_desc, i_moreinfo, i_iconurl, i_showlength)
{
	var parent = document.getElementById('content');
	
	// main <p>
	var paragraph = document.createElement('p');
	var main_class = document.createAttribute('class');
	main_class.nodeValue = alternateParagraph ? 'mainRow2' : 'mainRow';
	paragraph.setAttributeNode(main_class);

	alternateParagraph = !alternateParagraph;
    
	// checkbox
	var alarmCanBeSet = canSetAlarmForShow(i_time);
	var alarmExists = FernsehPlugin.alarmExistsForShow(i_title, i_channel, i_time, getListingDay());
	
	var checkbox = document.createElement('img');
	checkbox.setAttribute('class', "reminder");
	
	if (!alarmCanBeSet)
	{
	   checkbox.setAttribute('src', 'Images/ProgramRunning.png');
	   checkbox.setAttribute('title', 'Sendung läuft');
	} else {
	   if (alarmExists)
	   {
	   	   checkbox.setAttribute('src', 'Images/AlarmOn.png');
	   	   checkbox.setAttribute('title', 'Alarm ist an');
	   } else {
	   	   checkbox.setAttribute('src', 'Images/AlarmOff.png');
	   	   checkbox.setAttribute('title', 'Alarm ist aus');
	   }
	   var thisButtonID = "buttonID"+currentID++;
	   checkbox.setAttribute("id", thisButtonID);
	   checkbox.setAttribute("onClick", "toggleShow(\"" + i_title + "\",\"" + i_time + "\",\"" + i_channel + "\",\"" + getListingDay() + "\",\"" + i_iconurl + "\",\"" + thisButtonID + "\");");
	}

	paragraph.appendChild(checkbox);
	
	// the time
	var time = document.createElement('div');
	time.setAttribute('class', "time");
	var time_data = document.createTextNode(i_time);
	time.appendChild(time_data);
	
	paragraph.appendChild(time);
	
	// channel
	var channel = document.createElement('div');
	channel.setAttribute("class", "channel");
	var channel_data = document.createTextNode(i_channel);
	channel.appendChild(channel_data);
	
	paragraph.appendChild(channel);
	
	// title
	var title_data = document.createTextNode(i_title);
	if(i_moreinfo != "") {
	   var title_link = document.createElement('a');
	   var paraID = "infoParagraphID" + currentID++;
	   title_link.setAttribute("href", 'javascript:getShowDescription("' + i_moreinfo + '", "' + paraID + '");');
	   paragraph.setAttribute('id', paraID);
	   title_link.appendChild(title_data);
	   paragraph.appendChild(title_link);
	}
	else {
	   paragraph.appendChild(title_data);
	}
	
	// togglebutton
	if(i_desc) {
		var descs = i_desc.split("<br>");
	    var showDescOn = document.getElementById("kurzInfoStandard").checked;
		var img = document.createElement('img');
		if (showDescOn) img.setAttribute('src', "Images/iButtonGrau.png");
		else img.setAttribute('src', "Images/iButton.png");
		img.setAttribute('class', "toggleshortinfo");
		img.setAttribute('onclick', "toggleRowId(this.parentNode, this)");
		
		paragraph.appendChild(img);
    
        // moreinfo
        var desc = document.createElement('p');
        var desc_class = document.createAttribute('class');
        desc_class.nodeValue = 'descRow';
        var desc_data = document.createTextNode(descs[0]);
        
        desc.setAttributeNode(desc_class);
        
        if (showDescOn) desc.style.display = 'block';
        
        desc.appendChild(desc_data);
        
        // "<br>anschl. Nachrichten"
        for (z = 1; z < descs.length; z++)
        {
        	desc.appendChild(document.createElement("br"));
        	var textnode = document.createTextNode(descs[z]);
        	desc.appendChild(textnode);
        }
        
        if (i_showlength != "")
        {
            // if available, add the length of the show below the short desc
            var showlength = document.createElement('span');
            var showlength_class = document.createAttribute('class');
            showlength_class.nodeValue = 'showlength';
            
            showlength.setAttributeNode(showlength_class);
            showlength.appendChild(document.createTextNode(i_showlength));
            
            desc.appendChild(showlength);
        }
	}
	
	// append
	parent.appendChild(paragraph);
	if(i_desc)
	   parent.appendChild(desc);
}

function purgeParagraphs() {
	var parent = document.getElementById('content');
	var elements = parent.childNodes;
	var a = elements.length;
	
	for(i = a-1; i >= 0; i--) {
        if(elements[i] != null)
    		parent.removeChild(elements[i]);
	}
}



function canSetAlarmForShow(time)
{
    var day = getListingDay();
    
    if (day == 8) return false; // gestern
    if (day > 0) return true;
    
    var showDay;
    var now = new Date();

    var showDate = time.split(".");
	var showHour = Math.abs(showDate[0]);
	var showMinute = Math.abs(showDate[1]);
	
	if((showHour <= 5) && (now.getHours() >= 12))
		showDay = now.getDate() + 1;
	else if((showHour > 5) && (now.getHours() <= 5))
		showDay = now.getDate() - 1;
	else
		showDay = now.getDate();
	
    var theShow = new Date(now.getFullYear(), now.getMonth(), showDay, showHour, showMinute, 00);
    
    return (now < theShow);
    
	var date = new Date();
    var nowHour = date.getHours();
	var nowMinute = date.getMinutes();
	var nowInMinutes = (60 * nowHour) + nowMinute;
	var showDate = time.split(".");
	var showHour = Math.abs(showDate[0]);
	var showMinute = Math.abs(showDate[1]);
	var showInMinutes = (60 * showHour) + showMinute;	
	
	//alert(time + " >> " + showDate[0] +" >> "+showDate[1]);
	//alert("nh "+nowHour + " >> nm " + nowMinute + " >> sh "+showHour+" >> sm "+showMinute +" >> nim "+nowInMinutes +" >> sim "+showInMinutes);
	
	if (showInMinutes > nowInMinutes) return true;
	
	if ((nowHour > 4) && (showHour <= 4)) return true; // "now" is past 4, show starts past midnight, before 4; assume next day
	return false;
}

function getShowDescription(requesturl, callingID)
{
    if (currentlyloading) return;
    currentlyloading = true;
    
    callingobj = document.getElementById(callingID);
    
    if (null != previousShowObject)
    {
        previousShowObject.setAttribute('class', previousShowClass);
    }
    previousShowObject = callingobj;
    previousShowClass = previousShowObject.getAttribute("class");
    callingobj.setAttribute('class', 'highlightrow');

    document.getElementById('drawercontent').innerHTML = "<div class=\"faded\">Lade Beschreibung...</div>";
    resizeDrawer();
    
    currentShowDescURL = requesturl;

	req = new XMLHttpRequest();
    req.onreadystatechange = parseShowDescription;
    req.open("GET", requesturl, true);
    req.setRequestHeader("Cache-Control", "no-cache");
    req.send(null);
}

function parseShowDescription()
{
	//alert('parseShowDescription() called');
	if (req.readyState == 4) currentlyloading = false;
    if ((req.readyState == 4) && (req.status == undefined))
    {
        document.getElementById('drawercontent').innerHTML = "";
    	resizeDrawer();

    	showError();
    	return;
	}
	if (!((req.readyState == 4) && (req.status >= 200) && (req.status < 400))) return;
	
	rawShow = req.responseText;
	lines = rawShow.split("\n");
	rsource = lines.join("");
    
    showregexp = /<\/table>\s*<span class="text">(.*?)\s*<\/span/;
	showraw = rsource.match(showregexp);
    show = showraw[1];
    
    // sometimes they link to descriptions, but the description is "xxx".
    // instead of displaying "xxx" as description, say that there is none.
    if (show.length < 6)
    {
		show = "<div class=\"faded\">Keine Beschreibung vorhanden.</div>";
		document.getElementById('drawercontent').innerHTML = show;
		resizeDrawer();
		return;
    }
    //if ((show.length < 6) && (show.indexOf("xxx") != -1)) show = "<div class=\"faded\">Keine Beschreibung vorhanden.</div>";
    
    var startsearch = (show.length / 2) + 1;
    var doSearch = true;
    
    while (doSearch)
    {
    	var thischar = show.charAt(--startsearch);
    	if ((thischar == ' ') || (thischar == '.')) doSearch = false;
    	
    	if (startsearch == 0) doSearch = false;
    }
    
    //alert(show);
    show = show.substring(0, startsearch);
    //alert(show);
    
    show += "&hellip;<br /><a href=\"javascript:widget.openURL('" + currentShowDescURL + "');\">Mehr &#187;</a>";
    
    document.getElementById('drawercontent').innerHTML = show;
    resizeDrawer();
}

function showPrevious()
{
    if (previous == null) return;
    getURL("http://www.tvtoday.de" + previous);
}

function showNext()
{
    if (further == null) return;
    getURL("http://www.tvtoday.de" + further);
}

function scrollwheel(event)
{
	if (scrollTrack.style.display == 'none') return;
    delta = window.event.wheelDelta/10;
    // delta > 0 rad nach oben
    // delta < 0 rad nach unten
	
	var newv = (parseInt(document.getElementById('content').style.top.replace(/px/, ''))) + delta;
	newv += 'px';
    document.getElementById('content').style.top = newv;
	calculateAndShowThumb(document.getElementById('content'));
}

function reminderIntervalChanged()
{
	var opt = document.getElementById("erinnerung");
	var optval = opt.options[opt.selectedIndex].value;

	if (FernsehPlugin) FernsehPlugin.setSecondsBeforeReminder(""+optval);
}

function openDiagnosis()
{
	if(window.widget)
	    widget.openApplication("com.apple.NetworkDiagnostics");
}
